
#import "StarView.h"

@interface StarView ()

@property (nonatomic, strong) UIView *starBackgroundView;
@property (nonatomic, strong) UIView *starForegroundView;
//设置两个全局的变量，方便后面的显示判断
@property (nonatomic) float starWidth;
@property (nonatomic) float spaceWidth;

@end
@implementation StarView

- (id)initWithFrame:(CGRect)frame space:(float)space starWidth:(float)wid EmptyImage:(NSString *)Empty StarImage:(NSString *)Star{
    
    self = [super initWithFrame:frame];
    if (self) {
        self.starWidth = wid;
        self.spaceWidth = space;
        self.starBackgroundView = [self buidlStarView:Empty];
        self.starBackgroundView.backgroundColor = [UIColor redColor];
        self.starForegroundView = [self buidlStarView:Star];
        [self addSubview:self.starBackgroundView];
        //提前先把这个加载上去
        [self addSubview:self.starForegroundView];
        self.starForegroundView.frame = CGRectMake(self.starForegroundView.frame.origin.x,self.starForegroundView.frame.origin.y,0,self.starForegroundView.bounds.size.height);
        self.userInteractionEnabled = YES;
        
        /**点击手势*/
        UITapGestureRecognizer *tapGR=[[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(tapGR:)];
        [self addGestureRecognizer:tapGR];
        
        /**滑动手势*/
        
        UIPanGestureRecognizer *panGR = [[UIPanGestureRecognizer alloc] initWithTarget:self action:@selector(panGR:)];
        [self addGestureRecognizer:panGR];
    }
    return self;
}

- (UIView *)buidlStarView:(NSString *)imageName
{
    CGRect frame = self.bounds;
    
    UIView *view = [[UIView alloc] initWithFrame:frame];
    view.clipsToBounds = YES;
    
    
    for (int j = 0; j < 5; j ++)
    {
        UIImageView *imageView = [[UIImageView alloc] initWithImage:[UIImage imageNamed:imageName]];
        imageView.frame = CGRectMake(j*self.starWidth+(j+1)*self.spaceWidth, 0, self.starWidth, self.starWidth);
        [view addSubview:imageView];
    }
    
    return view;
}

//单击手势
-(void)tapGR:(UITapGestureRecognizer *)tapGR{
    CGPoint tapPoint = [tapGR locationInView:self.starBackgroundView];
    if (tapPoint.x<0||tapPoint.x>self.starBackgroundView.bounds.size.width) {
        return;
    }
    float width = tapPoint.x/self.starBackgroundView.bounds.size.width*5;//满分是5分，可以修改这个5
    self.starForegroundView.frame = CGRectMake(self.starForegroundView.frame.origin.x,self.starForegroundView.frame.origin.y,tapPoint.x,self.starForegroundView.bounds.size.height);
    float s = 0;
    NSLog(@"点击分数:%.4f",width);
    //这个部分是分数的一个判断，如果有需要，可以修改此判断
    if (tapPoint.x < self.spaceWidth) {
        s = 0;
    }else if (tapPoint.x > self.spaceWidth && tapPoint.x < self.spaceWidth*2+self.starWidth*1){
        s = 1;
    }else if (tapPoint.x >= self.spaceWidth*2+self.starWidth*1 && tapPoint.x < self.spaceWidth*3+self.starWidth*2){
        s = 2;
    }else if (tapPoint.x >= self.spaceWidth*3+self.starWidth*2 && tapPoint.x < self.spaceWidth*4+self.starWidth*3){
        s = 3;
    }else if (tapPoint.x >= self.spaceWidth*4+self.starWidth*3 && tapPoint.x < self.spaceWidth*5+self.starWidth*4){
        s = 4;
    }else if (tapPoint.x >= self.spaceWidth*5+self.starWidth*4){
        s = 5;
    }
    if (_delegate) {
        [_delegate getScore:width];
        [_delegate getScoreWithIndex:s index:_index];
    }
    
    //如果需要整星的显示，需要根据计算的分数重置self.starForegroundView.frame这里就不再写了
}

//拖动手势（主要是星级的判断部分）
- (void)panGR:(UIPanGestureRecognizer *)panGR
{
    CGPoint panPoint = [panGR locationInView:self.starBackgroundView];
    if (panPoint.x<0||panPoint.x>self.starBackgroundView.bounds.size.width) {
        return;
    }
    float width = panPoint.x/self.starBackgroundView.bounds.size.width*5;//满分是5分，可以修改这个5
    self.starForegroundView.frame = CGRectMake(self.starForegroundView.frame.origin.x,self.starForegroundView.frame.origin.y,panPoint.x,self.starForegroundView.bounds.size.height);
    float s = 0;
    NSLog(@"拖动分数:%.4f",width);
    //这个部分是分数的一个判断，如果有需要，可以修改此判断
    if (panPoint.x < self.spaceWidth) {
        s = 0;
    }else if (panPoint.x > self.spaceWidth && panPoint.x < self.spaceWidth*2+self.starWidth*1){
        s = 1;
    }else if (panPoint.x >= self.spaceWidth*2+self.starWidth*1 && panPoint.x < self.spaceWidth*3+self.starWidth*2){
        s = 2;
    }else if (panPoint.x >= self.spaceWidth*3+self.starWidth*2 && panPoint.x < self.spaceWidth*4+self.starWidth*3){
        s = 3;
    }else if (panPoint.x >= self.spaceWidth*4+self.starWidth*3 && panPoint.x < self.spaceWidth*5+self.starWidth*4){
        s = 4;
    }else if (panPoint.x >= self.spaceWidth*5+self.starWidth*4){
        s = 5;
    }
    
    if (_delegate) {
        [_delegate getScore:width];
        [_delegate getScoreWithIndex:s index:_index];
    }
    //如果需要整星的显示，需要根据计算的分数重置self.starForegroundView.frame这里就不再写了
}
@end
